#made by tak2hata  http://onigiriburning.so.land.to/
#Sketchup plugin Exporter for OBJMTL and GI Renderer

#Version:
#0.1 2009/06/17 First release.
#0.2 2009/06/30 Japanese convert by wordlist and ascii code
#....
#1.0 2009/10/25 Change to Use SuperClass. ruby files by each render engine
#1.1 2012/1/15 It works on Sketchup v8+.

#This Script export Obj & Mtl files.
#when using SuperClass,it can export to Various Render engine,too.
#-Render List-
#Exporter For Lux Render  http://www.luxrender.net/
#Exporter For Vidro Render  http://www.vidro-project.com/
#Exporter For Sunflow Render(bug:sometimes renderer stop in progress.)   http://sunflow.sourceforge.net/
#Exporter For RedQueen Render  http://www.redqueenrenderer.com/
############
# How To Use
#The OBJ file and the MTL file can be written usually. 
#It is possible to write it to each render with the file for render of the addition. 
#It is necessary to direct the place in the execution file of render at the rendering first time. 
#Definition of material:
#   The attribute is read from the material name of Sketchup.
#   Only the upcase of alphabet is basically read. 
#   ,like  'GLASS'.
#   ,like  'GLASS_REFL10_SPEC10'.
#   ,like  'SHINY_REFL10_ROUGH20'.
#   ,like  'GLOSSY_SPEC10_ROUGH10'.
#   ,like  'MATTE'.
#   ,like  'MTRANS'.This convert to "Matte Translucent" in Lux Render.
#   ,like  'MATTE_BUMP20'.This convert texture to bumpmapping.
#   ,etc.
#Definition of lighting:
#   It specifiesin the material name of Sketchup. 
#   Only the upcase of alphabet is basically read. 
#   ,like 'EMIS100'.
#   ,like 'POINTLIGHT100' and 'SPOTLIGHT80_RADIUS75_FALLOFF35'
#   ,etc.
#   Faces where the material of the source of light was attached converted into a source of light. 
#   Faces of the same material in the group is converted into one source of light. 
#   Make each source of light a group basically. 
#
#Refer to the material of sample SKP file. 
############
#file_loaded? "SU2OBJMTL.rb"
#$kconv = Sketchup.find_support_file "kconv.rb", "Plugins/"
#$nkf = Sketchup.find_support_file "nkf.so", "Plugins/"
#require "kconv" if $kconv and $nkf
#Replace word like japanese method changed.More Simply.

PRECISION = "%.8f"
PRECISION6 = "%.6f"
SCALE_FACTOR = 0.0254

class SU2RENDER
	def make_material_thumb()
	end
	def material_batch_file( cmatname )
	end


	def find_render()
		execname = "*.exe"
		if @engine_ext_name != nil
			execname = "*.bat" if @engine_ext_name == ".bat"
		end
		#execname = File.basename(@render_path,".exe")
		render_path=UI.openpanel("Locate Render(#{execname})","",execname)
		if FileTest.exist?(render_path)
			@render_path = render_path
			##@render_path.gsub!(/\\/,"/")
			@render_path.gsub!(/\\/, File::SEPARATOR )
			@wdlg.execute_script("document.getElementById('render_engin').value='#{@render_path}';")
			return true
		else
			return false
		end
	end
	def render_check()
		if FileTest.exist?(@render_path)
			return true
		else
			status = find_render
			return status
		end
	end
	def check_rsi_renderpath( rs_name = "" )
		##rs_path = @thisdir + "\/" + File.basename( rs_name)
		rs_path = File.join( @thisdir , File.basename( rs_name) )
		render_path = ""
		if FileTest.exist?(rs_path) and File.extname(rs_path) == ".rsi"
			ini_file = File.new(rs_path,"r")
	  		ini_file.each{|line_p|
	  			line = line_p#%(#{line_p})
	  			##render_path = line.split(",")[1].gsub(/\\/,"/").chomp if /^render_engine,/ =~ line
				render_path = line.split(",")[1].gsub(/\\/, File::SEPARATOR ).chomp if /^render_engine,/ =~ line
				#break if render_path != ""
	  		}
	  		ini_file.close
		end
		return render_path
	end
	def load_render_setting( rs_name = "")
	end

	def save_render_setting()
	end

	def get_objmtl_ini( rsiname = "" )
		@render_setting_file = ""
		@thisdir = File.dirname(File.expand_path(__FILE__))
		Dir.chdir(@thisdir)

		tbuff_arr = []
		renderlist = Hash.new
		path= @thisdir + "\/su2objmtl2.ini"

		if FileTest.exist?(path)
			ini_file=File.new(path,"r")
	  		ini_file.each{|line_p|
	  			line = line_p#%(#{line_p})
	  			tbuff_arr.push line.chomp
	  			if /^render_engine,/ =~ line
		  			splt = line.chomp.split(/,/)
		  			renderlist[ splt[1].upcase ] = splt[2] if splt[1] != ""
	  			end
	  		}
	  		ini_file.close
			chk_saveini = false
  			rsi_name = rsiname.upcase
  			@render_path = ""
	    	@render_path = renderlist[ rsi_name ] if renderlist.key?(rsi_name) != false
		end
	end
	def save_objmtl_ini( rsiname = "" )
		tbuff_arr = []
		renderlist = Hash.new
		path = @thisdir + "\/su2objmtl2.ini"
		if FileTest.exist?(path)
			read_ini_file=File.new(path,"r")
	  		read_ini_file.each{|line_p|
	  			line = line_p#%(#{line_p})
	  			tbuff_arr.push line.chomp
	  			if /^render_engine,/ =~ line
		  			splt = line.chomp.split(/,/)
		  			renderlist[splt[1]] = splt[2] if splt[1] != ""
	  			end
	  		}
			read_ini_file.close
  		end
		this_name = rsiname.upcase

		ini_file=File.new(path,"w")
		ini_file.puts tbuff_arr[0]
		chk_rs = false
		renderlist.each{| rsi_name,render_path |
			if rsi_name.upcase == this_name
				ini_file.puts "render_engine,#{this_name},#{@render_path}"
				chk_rs = true
			else
				ini_file.puts "render_engine,#{rsi_name},#{render_path}"
			end
		}
		if chk_rs == false
			ini_file.puts "render_engine,#{this_name},#{@render_path}"
		end
		ini_file.close
	end

	def load_parameta()
			Sketchup.set_status_text "loading"
			model=Sketchup.active_model
			ad = model.attribute_dictionary("suobj_setting")
			if( ad != nil )
				 @ibl_file = ad["@ibl_file"] if ad["@ibl_file"]
				 ##@ibl_file.gsub!(/\\/,"/")
				 @ibl_file.gsub!(/\\/, File::SEPARATOR )
				 @ibl_rgb = ad["@ibl_rgb"] if ad["@ibl_rgb"]
				 @fr = ad["@fr"] if ad["@fr"]
				 @use_sun = ad["@use_sun"] if ad["@use_sun"]
				 @wdlg.execute_script("document.getElementById('ibl_file').value ='#{@ibl_file}';") if ibl_file
				 @wdlg.execute_script("document.getElementById('ibl_rgb').value ='#{@ibl_rgb}';") if ibl_rgb
				 @wdlg.execute_script("document.getElementById('fr').value ='#{@fr}';") if @fr
				 @wdlg.execute_script("document.getElementById('us_yes').selected =true;") if @use_sun and @use_sun == "true"
				 @wdlg.execute_script("document.getElementById('us_no').selected =true;") if @use_sun and @use_sun == "false"
				 Sketchup.set_status_text "param loaded"
			end
	end

	def save_parameta()
			model=Sketchup.active_model
			ad = model.attribute_dictionary("suobj_setting",true)
			ad["@ibl_file"] = @ibl_file if @ibl_file
			ad["@ibl_rgb"] = @ibl_rgb if @ibl_rgb
			ad["@fr"] = @fr.to_s if @fr
			ad["@use_sun"] = @use_sun.to_s if @use_sun != nil
	end

	def render_show_webdialog
	end

	def startexport()
	end
######
	def start_export_objmtl( chk_onefile = true , chk_air3d = false)
		all_init
		@obj_onefile = 'yes' if chk_onefile == true
		save_filename = UI.openpanel "Save OBJ File", "", "*.obj"
		return if save_filename == nil
		savefile = File.expand_path(save_filename)
		savefile = savefile + ".obj" if File.extname(savefile).upcase != ".OBJ"
		savefile.gsub!(/\//,'\\')
		@render_path = savefile
		@scenefile = File.basename(savefile)
		@bbscale = (1.000).to_f
		@air3d = chk_air3d
		if chk_air3d == true
			@textures_prefix = ""
			bb = Sketchup.active_model.bounds
			dist = bb.max.distance bb.min
			@bbscale = 1.0
		end
		export()
	end
	
	def all_init
		setting_init
		buffer_init
		jap2englist
	end
	
	def setting_init
		@scenefile = 'default.obj'
		@batchcode = ''
		@objmode = true
		@use_textures = true
		@use_sun = false
		@image_type = "jpg"
		@image_size = "0x0"
		@gi = 256
		@oversample = 8
		@fr = nil
		@autorender = false
		@openimage = false
		@smooth = true
		@ibl_rgb = "0 0 0"
		@ibl_file = ""
		@render_path = ""
		@obj_onefile = 'yes'
		@scene_dir = ''
		@textures_prefix = 'tx_default'
		@v_cnt = 0
		@a_cnt = 0
	end
	def buffer_init
		@obj_list = []# if not @obj_list
		@s2v_model_textures = []# if not @model_textures
		@texture_exportpath = ""# if not @texture_exportpath
		@s2v_used_material = []
		#@material_list = Sketchup.materials
		#@texture_exportpath = File.join(File.dirname(@output_filename),@textures_prefix,File.basename(@output_filename,".*" ))
	end

	def export()#(objmode = true,auto = true,use_textures = true,use_sun = true,image_type = "jpg",image_size="320x180",gi = 256,oversample = 8,openimage = true,ibl = "")
		
		buffer_init if @objmode == true
		starttime = Time.now.to_f
	    @title = Sketchup.active_model.title
	    @title = "Untitled" if @title.length == 0
		@title = enc_kconv(@title)
		@export_dir = File.dirname(@render_path) + "\\" + @scene_dir
	    if FileTest.exist? (@export_dir)
	    else
	        Dir.mkdir(@export_dir)
	    end
		@scenefile = enc_kconv(@scenefile)
		@scenefile =  File.join(@export_dir,(@scenefile))

		Sketchup.set_status_text "creat Scene_file"
		export_render_scene()

		Sketchup.set_status_text "creat batch_file"
		bfile = create_batch_file()#,image_type,image_size,gi,oversample,openimage)
		##bfile.gsub!(/\\/,"\/")
		bfile.gsub!(/\\/,File::SEPARATOR)

		wastetime = Time.now.to_f - starttime
		Sketchup.set_status_text "OBJ&MTL export finished! time is #{wastetime} sec"
		
		UI.openURL bfile if @autorender == true
	end

	def create_batch_file()#,image_type = "png",image_size="320x180",gi = 256,oversample = 8,openimage = true)
	  bfile = "none"
	end

	def export_obj()
		title = @title
		ents = Sketchup.active_model.entities
	    #@verts = []
	    #@vcnt = 0
		objname = title + "_main"
		objname = enc_kconv(objname)
		Sketchup.set_status_text "export main mesh"
	    if Sketchup.active_model.entities.find{|e| e.is_a?(Sketchup::Face) }
			@obj_list.push [objname,nil,"default_mat"] 
		    export_entities(ents.find_all{|e| e.is_a?(Sketchup::Face) }, objname,"default_mat") if ents.find{|e| e.is_a?(Sketchup::Face) } != nil
		end
		Sketchup.set_status_text "export main mesh end"

		t = Geom::Transformation.axes( Geom::Point3d.new(0,0,0), Geom::Vector3d.new(1,0,0), Geom::Vector3d.new(0,1,0), Geom::Vector3d.new(0,0,1) )

	    ents.find_all{|e| e.is_a?(Sketchup::Group) }.each{|g| export_group(g, title,t) }# if grps.length != 0
		
	    ents.find_all{|e| e.is_a?(Sketchup::ComponentInstance) }.each{|c| export_ci(c, title,t) }# if cmps.length != 0
	end

	def export_ci(ci, title,t = Geom::Transformation.new,mat = nil)
		return if ci.hidden? == true or ci.layer.visible? == false
		ot = t * ci.transformation
		defmate = mat if mat != nil and ci.material == nil
		defmate = ci.material if ci.material != nil
		#has_texture = nil
		#has_texture = ci.material.texture if ci.material != nil
		#store_textured_entities(ci) if has_texture
		@s2v_used_material.push defmate

		id = ci.entityID
		name = ci.definition.name
		name = "#{id}" if name.length == 0
		#UI.messagebox "export ci #{name}"
		name.gsub!(/[\\\/]/,"_")
		objname = title + "_comp_" + name
		objname = enc_kconv(objname)
		matname = nil
		if defmate != nil
			matname = enc_kconv(defmate.display_name)
		end
		matname = "default_mat" if matname == nil
		checker = false
		if ci.definition.entities.find{|e| e.is_a?(Sketchup::Face)}
			export_entities(ci.definition.entities.find_all{|e| e.is_a?(Sketchup::Face) }, objname ,matname,ot,defmate ) if @obj_onefile == "yes" or @obj_list.find{|ol| ol[0] == objname } == nil
			@obj_list.push [objname,ot,matname]
		end

		(ci.definition.entities.find_all{|e| e.is_a?(Sketchup::Group) }).each{|f| export_group(f,title,ot,defmate) }
	    (ci.definition.entities.find_all{|e| e.is_a?(Sketchup::ComponentInstance) }).each{|f| export_ci(f,title,ot,defmate) }
	end

	def export_group(g, title,t = Geom::Transformation.new,mat = nil)
		return if g.hidden? == true or g.layer.visible? == false
		ot = t * g.transformation
		defmate = mat if mat != nil and g.material == nil
		defmate = g.material if g.material != nil
		#has_texture = nil
		#has_texture = g.material.texture if g.material != nil
		#store_textured_entities(g) if has_texture
		@s2v_used_material.push defmate

		id = g.entityID
		#name = g.name.empty? ? "#{id}" : g.name
		name = "#{id}_" + g.name
		name.gsub!(/[\\\/]/,"_")
		objname = title + "_g_" + name
		objname = enc_kconv(objname)
		matname = nil

		if defmate != nil
			matname = enc_kconv(defmate.display_name)
		end

		matname = "default_mat" if matname == nil


		if g.entities.find{|e| e.is_a?(Sketchup::Face) }
			export_entities(g.entities.find_all{|e| e.is_a?(Sketchup::Face) }, objname,matname,ot,defmate ) if @obj_onefile == "yes" or @obj_list.find{|ol| ol[0] == objname } == nil
			@obj_list.push [objname,ot,matname]
		end

		#g.entities.each{|e| UI.messagebox e.typename }
	    g.entities.find_all{|e| e.is_a?(Sketchup::ComponentInstance) }.each {|f| export_ci(f,title,ot,defmate) }
		g.entities.find_all{|e| e.is_a?(Sketchup::Group) }.each {|f| export_group(f,title,ot,defmate) }
	end

	def export_entities(entities,objname,default_matname = "",t = nil,defmate = nil )
	    mats = []
	    mats.push nil
	    Sketchup.active_model.materials.each{|mat|
	    	mats.push mat
	    }
		meshes = Array.new
		vts = Array.new
		uvs = Array.new
		nos = Array.new
		f_uvs =  Array.new
		f_nos =  Array.new
		f_vts =  Array.new

		#mshs = nil
		f_vcount = 1
		msh = Geom::PolygonMesh.new
		mats.each_with_index{|mat,mc|
			#has_texture = nil
			#has_texture = mat.texture if mat != nil
			faces = entities.find_all { |e| e.is_a?(Sketchup::Face) and ((mat == nil and e.material == nil and e.back_material == nil ) or (mat != nil and e.material == mat) or (mat != nil and e.material == nil and e.back_material == mat)) }
			if faces.length != 0
				#store_textured_entities(faces[0]) if (has_texture)
				@s2v_used_material.push mat
			end
			matname = ""
			if mat != nil
				matname = enc_kconv(mat.display_name)
			end

			meshes = []
			vts = []
			uvs = []
			nos = []
			#mshs = nil
			Sketchup.set_status_text "face search"
			faces.each{|e|
				next if e.hidden? == true or e.layer.visible? == false
				msh = e.mesh 5
				next if msh == nil

					f_uvs = (1..msh.count_points).map{|i| [msh.points[i-1],msh.uv_at(i,1)] }
					f_nos = (1..msh.count_points).map{|i| [msh.points[i-1],msh.normal_at(i)] }
					f_uvs.uniq!
					f_nos.uniq!
					f_vts = f_uvs.map{|uvp| uvp[0] }
					f_vcount = 1
					f_vcount = vts.length + 1 if vts.length != 0
					#090806modify
					#if not e.loops.length == 1
						meshes.concat( msh.polygons.map{|p| [ p.map{ |px| (f_vts.index(msh.points[(px.abs-1)]) + f_vcount) } ] })
						#このmeshes はfaceの頂点番号の配列で、実際にはメッシュではないので注意。UV、Normalもこの頂点番号を繰り返す
						#3点で配列の１要素分になると思う
					#else
					#	meshes.concat( [ [e.outer_loop.vertices.map{|v| (f_vts.index(v.position) + f_vcount) }] ] )
					#end
					#090806modify end
					#Furを生やすメソッドの実行
					
					#f_vcount += vts.length - 1
					#fur_glowup( msh , matname , f_vts , f_uvs , f_nos , meshes , f_vcount , t ) if matname[/.*MAKEFUR.*/]
					uvs.concat(f_uvs) if f_uvs != nil
					vts.concat(f_vts) if f_vts != nil
					nos.concat(f_nos) if f_nos != nil
					#f_uvs = nil
					#f_nos = nil
					#f_vts = nil
					f_uvs = []
					f_nos = []
					f_vts = []

			}
			mesh_st_en = ""
			mesh_st_en = "end" if mc >= (mats.length-1)
			@meshes = meshes
			@uvs = uvs
			@nos = nos
			@vts = vts
			@faces = faces
			export_object_file mat, objname ,mesh_st_en,t if mat != nil
			export_object_file defmate, objname ,mesh_st_en,t if mat == nil
		}#materials.each

	end

def point_add( vec1 , vec2 )
	Geom::Point3d.new( vec1.x.to_f + vec2.x.to_f , vec1.y.to_f + vec2.y.to_f , vec1.z.to_f + vec2.z.to_f )
end

def vector_add( vec1 , vec2 )
	Geom::Vector3d.new( vec1.x.to_f + vec2.x.to_f , vec1.y.to_f + vec2.y.to_f , vec1.z.to_f + vec2.z.to_f )
end

def vector_subtract( vec1 , vec2 )
	Geom::Vector3d.new( vec1.x.to_f - vec2.x.to_f , vec1.y.to_f - vec2.y.to_f , vec1.z.to_f - vec2.z.to_f )
end

def vector_scale( vec1 , tf )
	Geom::Vector3d.new( vec1.x.to_f * tf.to_f , vec1.y.to_f * tf.to_f , vec1.z.to_f * tf.to_f )
end


	#ここをサブクラスに継承して使う　obj_codeがない場合はオーバーライドしない。(通常のobjファイルを出力）
	def export_object_file( mat, objname = "" ,mesh_st_en = "", tr = nil)
		#  @export_dir　共用エクスポート用ディレクトリ
		#  @scenefile:scene file 		共用シーンファイル名
		#  @objfile  :object file 		共用オブジェクトファイル名
		#  @mtlfile  :material file 	共用マテリアルライブラリファイル名
		#  PRECISION ：precision		共用数値フォーマット（小数点桁）
		#  SCALE_FACTOR:scale factor	共用スケール（インチをメートル）
		#  objname	:object name				今回のコンポーネントおよびグループ名
		#  objfile	:object file textstream		今回のオブジェクトファイル名
		#  tr		：object transformation		今回の変形度 
		# default_matname :デフォルトマテリアル名
		#  @meshes メッシュリスト	マテリアルごとのハッシュ
		#  @vts = vts	点リスト
		#  @uvs = uvs	UV座標リスト
		#  @nos = nos	法線リスト
		#  @hashall = true 穴ありか？
		Sketchup.set_status_text "export object to file"
		default_matname = "default_mat" if default_matname == ""
		o = Geom::Transformation.new
		o = tr if tr != nil
		#@objfile = File.join(@export_dir,(File.basename(@scenfile) + "_obj." + @obj_ext)) if @objfile == nil
		#objfile = File.join(@export_dir,("main_obj" + ".obj"))#objname
		#objfile = File.join(@export_dir,(@scenefile))#objname
		matname = default_matname
		mcur = -1
		Sketchup.active_model.materials.each_with_index{|airmat,mindx|
			if mat != nil
			mcur = mindx if mat.name == airmat.name
			end
		}
		mcur = mcur + 1
		if mat != nil
			matname = enc_kconv(mat.name)
		end
		#matname = default_matname if matname == ""
		return if @meshes == nil
		objname2 = objname.gsub(/[)( ]/,"")
		if @meshes.length != 0 and @vts.length != 0
			if @air3d == true
				@of.puts "g #{objname2}-#{matname}"
				@of.puts "usemtl default_mat"
			else
				if matname != nil
					@of.puts "g #{objname2}-#{matname}"
					@of.puts "usemtl #{matname}"
				else
					@of.puts "g #{objname2}-defmat"
					@of.puts "usemtl default_mat"
					matname = "default_mat"
				end
			end
		    @v_cnt = 0 if @v_cnt == nil

			@vts.each do |vt|
				vt = o * vt
				vt = Geom::Transformation.scaling( @bbscale ) * vt if @bbsacle != 1
				@of.puts "v #{PRECISION6 % vt.x.to_m.to_f} #{PRECISION6 % vt.z.to_m.to_f} #{PRECISION6 % (-vt.y.to_m.to_f)}"
			end
			@of.puts ""
			@nos.each do |vnor|
				nor = o * vnor[1]
				nor.normalize!
				@of.puts "vn #{PRECISION6 % (nor.x)} #{PRECISION6 % (nor.z)} #{PRECISION6 % (-nor.y)}"
			end
			@of.puts ""
			if @air3d == true
				gmax = (Sketchup.active_model.materials.count ** 0.5).to_i + 1
				ans = []
				ans[0] = ( mcur / gmax ).to_i.to_f #ans[0]が商　ans[1]が余り
				ans[1] = ( mcur % gmax ).to_f #ans[0]が商　ans[1]が余り
		 		@of.puts "vt #{PRECISION6 % ( 1.00 / gmax.to_f * ( ans[1].to_f + 0.05 ) )} #{PRECISION6 % ( 1.00 / gmax.to_f * ( ans[1].to_f + 0.05 ) )}"
		 		@of.puts "vt #{PRECISION6 % ( 1.00 / gmax.to_f * ( ans[0] + 0.95 ) )} #{PRECISION6 % ( 1.00 / gmax.to_f * ( ans[1].to_f + 0.05 ) )}"
		 		@of.puts "vt #{PRECISION6 % ( 1.00 / gmax.to_f * ( ans[0] + 0.95 ) )} #{PRECISION6 % ( 1.00 / gmax.to_f * ( ans[1].to_f + 0.95 )) }"
		 		@of.puts "vt #{PRECISION6 % ( 1.00 / gmax.to_f * ( ans[1].to_f + 0.05 ) )} #{PRECISION6 % ( 1.00 / gmax.to_f * ( ans[1].to_f + 0.95 )) }"
		 	end

			@uvs.each_with_index do |vuv,uvindx|
				uv = vuv[1]
				if @air3d == true
					#gmax = (Sketchup.active_model.materials.count ** 0.5).to_i + 1
					#ans = []
					#ans[0] = ( mcur / gmax ).to_i.to_f #ans[0]が商　ans[1]が余り
					#ans[1] = ( mcur % gmax ).to_f #ans[0]が商　ans[1]が余り
					#uvmod = uvindx % 3
					#if uvmod == 0
				 	#	@of.puts "vt #{PRECISION6 % ( 1.00/ gmax.to_f * ans[0] )} #{PRECISION6 % ( 1.00 / gmax.to_f * ans[1] )}"
					#elsif uvmod == 1
				 	#	@of.puts "vt #{PRECISION6 % ( 1.00/ gmax.to_f * ( ans[0] + 0.99 ) )} #{PRECISION6 % ( 1.00 / gmax.to_f * ans[1] )}"
					#elsif uvmod == 2
				 	#	@of.puts "vt #{PRECISION6 % ( 1.00 / gmax.to_f * ( ans[0] + 0.99 ) )} #{PRECISION6 % ( 1.00 / gmax.to_f * ( ans[1].to_f + 0.99 )) }"
					#end
			 	else
			 		@of.puts "vt #{PRECISION6 % (uv.x)} #{PRECISION6 % (uv.y)}"
			 	end
			end
			@of.puts ""
			@meshes.each_with_index{|mesh,ms_cnt|
				Sketchup.set_status_text "export count:#{ms_cnt}/#{@meshes.length} faces"
				#@of.puts "usemtl #{matname}" if @air3d == true
				f_str = "f"
				mesh.each do |pg|
					ac = 1
					pg.each{|j|
						k = j + @v_cnt
						ak = ac + @a_cnt
						if @air3d == true
							f_str += " #{k}/#{ak}/#{k}"
						else
							f_str += " #{k}/#{k}/#{k}"
						end
						ac += 1
					}
					@of.puts f_str
				end
			}
			@of.puts ""
			@a_cnt += 4 if @air3d == true
			@v_cnt += @vts.length if @vts.length > 0
		end
		#if mesh_st_en == "end" and @of != nil
		#	@v_cnt = nil
		#	@of.close
		#	@of = nil
		#end
		@meshes = nil
		@uvs = nil
		@nos = nil
		@vts = nil
	end

	#ここをサブクラスに継承して使う　scene_codeがない場合はオーバーライドしない。(通常のscene_txtファイルを出力）
	def export_render_scene()# ,usesun = true,ibl = "" )
		#  @export_dir　共用エクスポート用ディレクトリ
		#  @scenefile:scene file 		共用シーンファイル名
		#  @objfile  :object file 		共用オブジェクトファイル名
		#  @mtlfile  :material file 	共用マテリアルライブラリファイル名
		#  PRECISION ：precision		共用数値フォーマット（小数点桁）
		#  SCALE_FACTOR:scale factor	共用スケール（インチをメートル）
		@objfile = File.join(@export_dir,File.basename(@scenefile))
		@mtllib = File.basename(@scenefile,".*") + ".mtl"
		@mtlfile =  File.join(@export_dir,@mtllib)

		@of = File.new(@objfile, "w")
		@of.puts "units=meters" if @air3d != true
		@of.puts "mtllib #{@mtllib}"
		Sketchup.set_status_text "exportt OBJ_file"
		export_obj()
		@of.close if @of != nil
		
		Sketchup.set_status_text "creat MTL_file"
		export_textures
		export_mtl_material()
	end

	#ここをサブクラスに継承して使う　mtl_codeがない場合はオーバーライドしない。(通常のmtlファイルを出力）
	def export_mtl_material()
	#  @export_dir　共用エクスポート用ディレクトリ
	#  @scenefile:scene file 		共用シーンファイル名
	#  @objfile  :object file 		共用オブジェクトファイル名
	#  @mtlfile  :material file 	共用マテリアルライブラリファイル名
	#  PRECISION ：precision		共用数値フォーマット（小数点桁）
	#  SCALE_FACTOR:scale factor	共用スケール（インチをメートル）
	#file = File.join(@export_dir,(@mtlfile))
	#of = File.new(@mtlfile, "w")
		mf = File.new(@mtlfile, "w")
		if @air3d == true
			mf.puts "newmtl default_mat"
			mf.puts "Ka 0.500000 0.400000 0.300000"
			mf.puts "Kd 1.000000 1.000000 1.000000"
			mf.puts "Ks 0.500000 0.600000 0.800000"
			mf.puts "d 1.000000"
			mf.puts "Ns 50.000000"
			mf.puts "illum 2"
			mf.puts "map_Ka allmats.jpg"
			mf.puts "map_Kd allmats.jpg"
			mf.puts "map_Ks allmats.jpg"
			mf.puts "#"
			mf.puts "#EOF"
			mf.flush
			mf.close
			return
		end
		mf.puts "newmtl default_mat"
		mf.puts "Ka 0.300000 0.300000 0.300000"
		mf.puts "Kd 0.700000 0.700000 0.700000"
		mf.puts "Ks 0.000000 0.000000 0.000000"
		#mf.puts "Tr 0.000000"
		mf.puts "d 1.000000"
		mf.puts "Ns 50.000000"
		mf.puts "illum 2"
		mf.puts ""
		@s2v_used_material.uniq!
		@s2v_volumes = []
		#Sketchup.active_model.materials.each{|mat|
		@s2v_used_material.each{|mat|
			next if mat == nil
			matname = enc_kconv(mat.name)
			texturename = ""
			@emis = -1
			@refl = -1
			@spec = -1
			@ior = -1
			@back = -1
			@bump = -1
			@rough = -1
			@urough = -1
			@vrough = -1
			@sgm = -1
			@cauchy = -1
			exp = -1
			uexp = -1
			vexp = -1
			extinc = 15
			albedo = 1
			aniso = 0.01
			get_mat_expression matname

			texturename = ""
			if mat.texture != nil
				texturename = enc_kconv(File.basename(mat.texture.filename.to_s))
				texturename = @texnames_bymat[mat.name] if @texnames_bymat[mat.name]
				texturename = @textures_prefix + "\\" + texturename if@textures_prefix != ""
			end
			mf.puts "newmtl #{matname}"
			
			if mat.name[0,5] == "GLASS"
				mf.puts "Ka 0.100000 0.100000 0.100000"
				mf.puts "Kd 0.100000 0.100000 0.100000"
				mf.puts "Ks 0.300000 0.300000 0.300000"
				#mf.puts "Tr 0.800000"
				mf.puts "d 0.100000"
				mf.puts "Ni 1.4" if @air3d != true
				mf.puts "Ns 1.000000"
				mf.puts "illum 2"
			else
				if mat.name[0,9] == "SOFTLIGHT"
					mf.puts "Ka 1.000000 1.000000 1.000000"
					mf.puts "Kd 1.000000 1.000000 1.000000"
					mf.puts "Ks 1.000000 1.000000 1.000000"
					mf.puts "d 1.000000"
					mf.puts "illum 1"
					mf.puts "Ns 0.000000"
					#mf.puts "	Ke " + mat.color.to_a[0..2].collect{ |x| "%.3f" % ((x.to_f/255 ) * 50) }.join( " " ) if texturename == ""
					#mf.puts "	Ke 1.0 1.0 1.0" if not texturename == ""
					#mf.puts "	map_Ke #{texturename}" if not texturename == ""
				elsif mat.name[0,9] == "HARDLIGHT"
					mf.puts "Ka 1.000000 1.000000 1.000000"
					mf.puts "Kd 1.000000 1.000000 1.000000"
					mf.puts "Ks 1.000000 1.000000 1.000000"
					mf.puts "d 1.000000"
					mf.puts "Ns 0.000000"
					mf.puts "illum 1"
					#mf.puts "	Ke " + mat.color.to_a[0..2].collect{ |x| "%.3f" % ((x.to_f/255 ) * 100) }.join( " " ) if texturename == ""
					#mf.puts "	Ke 100.0 100.0 100.0" if not texturename == ""
					#mf.puts "	map_Ke #{texturename}" if not texturename == ""
					#mf.puts "#	HardLight 1"
				elsif @emis > 0
					mf.puts "Ka 1.000000 1.000000 1.000000"
					mf.puts "Kd 1.000000 1.000000 1.000000"
					mf.puts "Ks 1.000000 1.000000 1.000000"
					mf.puts "d 1.000000"
					mf.puts "Ns 0.000000"
					mf.puts "illum 1"
					#mf.puts "	Ke " + mat.color.to_a[0..2].collect{ |x| "%.3f" % ((x.to_f/255 ) * @emis) }.join( " " ) if texturename == ""
				elsif not mat.use_alpha?
					mf.puts "Ka 0.0 0.0 0.0"
					mf.puts "Kd " + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )) }.join( " " ) if texturename == ""
					mf.puts "Kd 1.0 1.0 1.0" if not texturename == ""
					if @spec > 0 or @refl > 0
						mf.puts "Ks " + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )) }.join( " " )
						mf.puts "d 1.000000"
						mf.puts "Ns #{PRECISION6 % @spec}"
					else
						mf.puts "Ks 0.1 0.1 0.1"
						mf.puts "d 1.000000"
						mf.puts "Ns 0.000000"
					end
					mf.puts "illum 2"
					mf.puts "map_Kd #{texturename}" if not texturename == ""
				elsif mat.use_alpha?
					mf.puts "Ka 0.0 0.0 0.0"
					mf.puts "Kd " + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255)) }.join( " " ) if texturename == ""
					mf.puts "Kd 1.0 1.0 1.0" if not texturename == ""
					if @spec > 0 or @refl > 0
						mf.puts "Ks " + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )) }.join( " " )
						mf.puts "d 1.000000"
						mf.puts "Ns #{PRECISION6 % @spec}"
					else
						mf.puts "Ks 0.1 0.1 0.1"
						mf.puts "d 1.000000"
						mf.puts "Ns 0.000000"
					end
					mf.puts "d #{PRECISION6 % (1 - mat.alpha) }"
					mf.puts "illum 2"
					mf.puts "map_Kd #{texturename}" if not texturename == ""
					#of.puts "	Diffuse	" + mat.color.to_a[0..2].collect{ |x| "%.3f" % ( mat.alpha * (x.to_f/255 )** 2.2 ) }.join( " " ) +" \"#{texturename}\""
				end
				#of.puts "	Transparency	" + (((1 - mat.alpha).to_s + " ") * 3) + "\"#{texturename}\"" if mat.use_alpha?

				#mf.puts "	Ni	" + ("%.3f" % @ior).to_s if @ior > 0
			end
		mf.puts "#"
		#of.puts "	Background	#{back}" if back != 0
		}
		mf.puts "#EOF"
		mf.flush
		mf.close
	end

	def get_mat_expression (matname)
	    useemis = matname[/.*EMIS(\d*).*/]
	    if useemis
		    @emis = 10
		    @emis = $1.to_f if $1 != nil
	    end
	    userefl = matname[/.*REFL(\d*).*/]
	    if userefl
			@refl = 0.2
		    @refl = $1.to_f / 100 if $1 != nil
		    @refl = 1 if @refl > 1
		end
	    usespec = matname[/.*SPEC(\d*).*/]
	    if usespec
	    	@spec = 0.1
		    @spec = $1.to_f / 100 if $1 != nil
		    @spec = 10 if @spec > 10
		    #スペキュラが１以上も設定しうるので、上限を10とした（マテリアル名上はSPEC1000が限界）
	    end
	    useior = matname[/.*IOR(\d*).*/]
	    if useior
	    	@ior = 1.0
		    @ior = $1.to_f / 100 if $1 != nil
		end
	    useback = matname[/.*BACK(\d*).*/]
	    if useback
	    	@back = 1
	    end
	    usebump = matname[/.*BUMP(\d*).*/]
	    if usebump
	    	@bump = 0.5
		    @bump = $1.to_f / 100 if $1 != nil
		    @bump = 1 if @bump > 1
	    end
	    usecauch = matname[/.*CAUC(\d*).*/]
	    if usecauch
	    	@cauchy = 0.1
		    @cauchy = $1.to_f / 100 if $1 != nil
		    @cauchy = 1 if @cauchy > 1
	    end
	    userough = matname[/.*ROUGH(\d*).*/]
	    if userough
	    	@rough = 0.1
		    @rough = $1.to_f / 100 if $1 != nil
		    @rough = 1.0 if @rough > 1
		end
	    useurgh = matname[/.*URGH(\d*).*/]
	    if useurgh
		    @urough = 0.1
		    @urough = $1.to_f / 100 if $1 != nil
		    @urough = 1 if @urough > 1
		end
	    usevrgh = matname[/.*VRGH(\d*).*/]
	    if usevrgh
		    @vrough = 0.01
		    @vrough = $1.to_f / 100 if $1 != nil
		    @vrough = 1 if @vrough > 1
		end
	    usesgm = matname[/.*SGM(\d*).*/]
	    if usesgm
	    	@sgm = 0.1
		    @sgm = $1.to_f / 100 if $1 != nil
		    @sgm = 1.0 if @sgm > 1
		end
	end
	def make_texturefolder()
		Sketchup.set_status_text "Making texture folder"
		@texture_exportpath = @export_dir
		@texture_exportpath = @export_dir + "\\" + @textures_prefix if @textures_prefix != ""
		if FileTest.exist? (@texture_exportpath)
		else
			Dir.mkdir(@texture_exportpath)
		end
	end
	def export_textures( cm_only = "" )
		make_texturefolder()
		txpts = []
		txpts.push [0, 0, 0]
		txpts.push [0, 1, 0]
		txpts.push [1, 1, 0]
		txpts.push [1, 0, 0]
		txgrp = Sketchup.active_model.entities.add_group
		txfc = txgrp.entities.add_face txpts
		savenames = []
		@texnames_bymat = Hash.new
		if cm_only == ""
			Sketchup.active_model.materials.each{|mat|
				if mat.texture != nil
					txfc.material = mat
					@s2v_model_textures.push([mat, txfc , true ])
					savename = enc_kconv(File.basename(mat.texture.filename.to_s))
					savename2 = get_uniqname( savenames ,savename.downcase )
					savenames.push savename2
					@texnames_bymat[mat.name] = savename2
					export_tex( txfc ,savename2 ,true )
				end
			}
		else#カレントマテリアルのみを判定
			mat = Sketchup.active_model.materials.current
			if mat.texture != nil
				txfc.material = mat
				savename = enc_kconv(File.basename(mat.texture.filename.to_s))
				@texnames_bymat[mat.name] = savename
				export_tex( txfc ,savename ,true )
			end
		end
		Sketchup.active_model.entities.erase_entities txgrp
		Sketchup.set_status_text "Exporting texture end"
	end

	def export_tex( ent ,filename , forb = true )
		tw = Sketchup.create_texture_writer
		status = tw.load(ent,forb)
		if status > 0
			#UI.messagebox @texture_exportpath + "|" + filename.to_s + "|" + forb.to_s
			#if ent.kind_of? Sketchup::ComponentInstance or ent.kind_of? Sketchup::Group
			#	tw.write( ent, File.expand_path(File.join(@texture_exportpath,filename)))
			#else
				tw.write( ent, forb , File.expand_path(File.join(@texture_exportpath,filename)))
			#end
		end
	end
	def get_uniqname( savenames =[] ,savename = "" )
		if savenames.index(savename)
			cnt = 1
			while cnt < 1000
				newname = File.basename(savename,".*") + cnt.to_s + File.extname(savename)
				return(newname) if savenames.index(newname) == nil
				cnt += 1
			end
		end
		return savename
	end
	def store_used_material(mat)
		#mat = enc_kconv(omat)
		@s2v_used_material.push mat if @s2v_used_material.find(){|m| m = mat} != nil
	end
	def store_textured_entities(e)
		#if (e.material.respond_to?(:texture) and e.material.texture !=nil)
		#	saved=false
		#	for i in @s2v_model_textures
		#		saved=true if i[0]== e.material
		#	end
		#	if saved==false
		#		@s2v_model_textures.push([e.material, e , true ])
		#	end
		#elsif e.kind_of? Sketchup::Face
		#	if (e.back_material.respond_to?(:texture) and e.back_material.texture !=nil)
		#		saved=false
		#		for i in @s2v_model_textures
		#			saved=true if i[0]== e.back_material
		#		end
		#		if saved==false
		#			@s2v_model_textures.push([e.back_material, e , false ])
		#		end
		#	end
		#end
	end
	def make_spotmap(sprad = 30, spfal = 0)
		width = 1
		height = 1024
	    line_size = width * 3 + (4 - (width * 3) % 4) % 4
	    buf_size = line_size * height
	    file_size = 14 + 40 + buf_size
	    data_offset = 14 + 40
		bit_count = 24
		buf = "\000" * buf_size
		
		make_texturefolder()
		
		spotname = "spotmap_#{sprad.to_i.to_s}_#{spfal.to_i.to_s}.bmp"
		spotimagepath = File.join(@texture_exportpath,spotname)
		f_sprad = 1.00 - sprad.to_f / 180.00
		f_spfal = spfal.to_f / 180.00
		(0..(height-1)).each{|i|
			ival = 0
			lat = i.to_f / height.to_f
			if lat > f_sprad
				ival = 255
				ival = (256 * ( lat - f_sprad ) / f_spfal).to_i if f_spfal != 0
				ival = 255 if ival > 255
			end
			(0..2).each{|j| buf[(height - 1 - i) * line_size + j ] = ival }
		}
	    open(spotimagepath, "wb") do |f|
	      f.print 'BM'
	      f.print [file_size, 0, data_offset].pack("l*")
	      f.print [40, width, height].pack("l*")
	      f.print [1,bit_count].pack("S*")
	      f.print [0,0,0,0,0,0].pack("l*")
	      f.print buf
	    end

		return spotname
	end
	def enc_kconv(str = "")
		#s=[]
		#s=str.each { |c| s<<[c.to_i].pack("w") }
		#new_str=[s].pack("m").chomp.gsub(/[\\\/:*?\"<>|+=]/,"")
		return nil if str ==nil
		return "" if str == ""
		new_str = str.gsub(/[\\\/:*?\"<>|+="#" %&]/,"_")
		new_str.gsub!(/[\[\]]/,"_")
		new_str.gsub!(/[\(\)\,]/,"_")
		#[^-\._A-Za-z0-9]
		##if new_str[/[ぁ-んァ-ヴ一-龠０-９ａ-ｚＡ-Ｚー]/] != nil
		if new_str[/[^-\._A-Za-z0-9]/] != nil
			@j2e_list.each_pair {|jap,eng|
		 #UI.messagebox "|||" +jap + "|||" + eng + "|||"
				new_str.gsub!( jap,eng )
			}
		#new_str.gsub!("マテリアル","Material")
		end
		japcount = 0
		##japcount = new_str.scan(/([ぁ-んァ-ヴ一-龠０-９ａ-ｚＡ-Ｚー])/).length.to_i if new_str[/[ぁ-んァ-ヴ一-龠０-９ａ-ｚＡ-Ｚー]/] != nil
		japcount = new_str.scan(/([^-\._A-Za-z0-9])/).length.to_i if new_str[/[^-\._A-Za-z0-9]/] != nil
		(0..japcount).each{|i|
			new_str.sub!(/([^-\._A-Za-z0-9])/, int2logos($1) )
			##new_str.sub!(/([ぁ-んァ-ヴ一-龠０-９ａ-ｚＡ-Ｚー])/, int2logos($1) )
		}
		#new_str.gsub!(/[\\\/:*?\"<>|+="#" ]/,"_")
		#new_str.gsub!(/[\[\]]/,"_")
		#if @kconv and @nkf
		#	  new_str = new_str.tosjis
		#else

		# new_str.gsub!(/[\\\/:*?\"<>|+="#" ]/,"_")
		#end
	  return new_str
	end
	def int2logos(tstr = "")
		return "" if tstr ==nil
		return "" if tstr == ""
		i = tstr.unpack("U*")[0].to_i- 10000
		return "" if i < 0
		new_str = "_"
		#logos="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
		logos="0123456789abcdefghijklmnopqrstuvwxyz"
		dm = []
		(0..10).each{|n|
			dm = i.divmod(logos.length.to_i + 1)
			new_str = new_str + logos[dm[1]-1].chr if not dm[1] == 0
			if dm[0] == 0
				return new_str
			else
				i = dm[0]
			end
		}
	end
	def jap2englist()
		@j2e_list = Hash.new
		je_path = File.dirname(__FILE__) +  "\/jap2eng.txt"
		if  FileTest.exist?(je_path)
				je_file= File.new(je_path,"r")
				je_file.read.each {|line|
					line.chomp!
					if line != ""
						 keys = line.split(",")
						 @j2e_list[keys[0].chomp] = keys[1].chomp
					end
				}
				je_file.close
		end
	end
	def makematerialgrid()
		model = Sketchup.active_model
		ents = model.active_entities
		mats = model.materials
		mggroup = ents.add_group
		mgents = mggroup.entities
		gsize = 1500.mm
		#左上から右上へ作り、それを下へと進めていく
		gmax = (mats.count ** 0.5).to_i
		(0..gmax).each{|y|
			(0..gmax).each{|x|
				pts = []
				pts[0] = [ ( x * gsize ),( - y * gsize ),0]
				pts[1] = [ ( ( x + 1 ) * gsize ),( - y * gsize ),0]
				pts[2] = [ ( ( x + 1 ) * gsize ),( ( - y - 1 ) * gsize ),0]
				pts[3] = [ ( ( x ) * gsize ),( ( - y - 1 ) * gsize ),0]
				fc = mgents.add_face pts
				mnum = y * ( gmax + 1 ) + x - 1
				if mnum == -1
				elsif mnum < mats.count
					fc.material = mats[ mnum ]
					fc.back_material = mats[ mnum ]
				end
				fc = nil
			}
		}
		mgents.each{|mge|
			mge.reverse! if mge.is_a?(Sketchup::Face)
		}
	end
	def camera_aspect_zero()
		camera = Sketchup.active_model.active_view.camera
		p_aspect = camera.aspect_ratio
		camera.aspect_ratio = 0.0
		p_flength = camera.focal_length
		camera.focal_length = p_flength * p_aspect if p_aspect != 0.0
	end
	
	def add_page_attr
		model = Sketchup.active_model
		sel = model.selection
		if sel[0].kind_of? Sketchup::SectionPlane
			sec = sel[0]
			pname = sec.get_attribute "su2objmtl", "onPage"
			pages = model.pages
			pgnames = pages.map{|pg| pg.name}
			prompts = ["Page select"]
			defaults = [pgnames[0]]
			defaults = [pname] if pname != nil
			list = [pgnames.join("|")]
			input = UI.inputbox prompts, defaults, list ,"断面とページを関連付ける"
			if input != nil
			sec.set_attribute "su2objmtl", "onPage", input[0].to_s
			end
		else
			
		end 
	end
	def array_add( arr1 , arr2 )
		arr3 = []
		(1..arr1.size).each{|cnt|
			arr3[cnt-1] = arr1[cnt-1].to_f + arr2[cnt-1].to_f if arr2[cnt-1] != nil
		}
		return arr3
	end
	def array_subtract( arr1 , arr2 )
		arr3 = []
		(1..arr1.size).each{|cnt|
			arr3[cnt-1] = arr1[cnt-1].to_f - arr2[cnt-1].to_f if arr2[cnt-1] != nil
		}
		return arr3
	end
	def array_product( arr1 , flo )
		arr3 = []
		(1..arr1.size).each{|cnt|
			arr3[cnt-1] = arr1[cnt-1].to_f * flo.to_f
		}
		return arr3
	end
	def calc_sec_modify( sech1, sech2, frame , nextframe , prevframe )
		fps = nextframe -  prevframe
		cframe = frame - prevframe
		arr1 = array_product( sech1 , ( ( fps.to_f - cframe.to_f ) / fps.to_f ) )
		arr2 = array_product( sech2 , ( cframe.to_f / fps.to_f ) )
		arr3 = array_add( arr1 , arr2 )
		return arr3
	end

end#of class


unless file_loaded? "su2objmtl.rb"
	su2objmtl = SU2RENDER.new
	main_menu = UI.menu("Plugins").add_submenu("OBJ_MTL Exporter")
	main_menu.add_item("OBJ Export(OneFile)") { su2objmtl.start_export_objmtl(true , false) }
	##main_menu.add_item("OBJ Export(air3d)") { su2objmtl.start_export_objmtl(true , true) }
	##main_menu.add_item("Make MaterialGrid") { su2objmtl.makematerialgrid }
	main_menu.add_item("Camera_Aspect to 0") { su2objmtl.camera_aspect_zero }
	##UI.add_context_menu_handler do |menu|
	##	menu.add_separator
	##	menu.add_item( "断面とページを関連付けする" ) { su2objmtl.add_page_attr }
	##end
end

file_loaded "su2objmtl.rb"
